<?php
/**
 * Cette classe me permet de récupérer facilement le favicon d'un site
 * 
 * L'utilisation de cette classe est ultra basique :
 *	$favIcon = new Favicon($urlSite);
 *	$urlFav = $favIcon->getFavicon();
 *
 * Copyright 2012-2013 Superbaillot
 * This file is part of Superbaillot's Project.
 *
 *  Superbaillot's Project is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Superbaillot's Project is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 */
class Favicon
{
	private $urlSite="";

	public function getUrlSite(){return  $this->urlSite;}
	public function setUrlSite($urlSite){ $this->urlSite = trim($urlSite);}


	public function __construct($url)
	{
		$this->setUrlSite($url);
	}

	/**
	 * fonction qui va récupérer le favicon d'un site s'il existe.
	 * @return String : url du favicon
	 */
	public function getFavicon()
	{
		$urlFav = "";
		$urlFavSecour = "";
		$nomFichier = "";
		$trouver = false;
		$url = $this->getUrlSite();
		
		$info = parse_url($url);
		
		$pro = $info['scheme'] . "://";
		$urlRacine = $info['host'];
		$url = $urlRacine . (isset($info['path']) ? $info['path'] : "");
		$contenuLigne = "";

		//on va essayer de récuperer le favicon de la page
		if ($fichier = @fopen($this->getUrlSite(), 'rb'))
		{
			//je sais, c'est moche, mais je ne suis pas un pro des regex, alors je fais ça en plusieurs fois
			//si je m'améliore, je pourrais essayer de faire ça en une regex
			$recherche = "#rel=[\",'].*icon[\",'].+href=[\",'](.+)[\",']#i";
			$recherche2 = "#type=[\",'].*icon[\",'].+href=[\",'](.+)[\",']#i";
			$recherche3 = "#href=[\",'](.+)[\",'].+rel=[\",'].*icon[\",']#i";
			$recherche4 = "#href=[\",'](.+)[\",'].+type=[\",'].*icon[\",']#i";

			$finHead = false;
			while( $ligne = @fgets($fichier))
			{
				//il m'est arrivé de voir la balise <link> sur 2 lignes, donc je concatène au cas ou. Quand je trouverais une correspondance, je réinitialise la variable dans le cas où ne autre balise ait l'attribut "href"
				$contenuLigne .= trim($ligne);

				//je m'arrete si on est plus dans le head
				if(strpos(strtolower($contenuLigne), "</head") === 0 || $finHead)
				{
					break;
				}

				//il m'est arrivé de voir plusieurs balises sur une ligne, on va donc analyser balise par balise
				$listeBalise = explode(">", $contenuLigne);
				
				foreach($listeBalise as $balise)
				{
					if(strpos(strtolower($balise), "</head") !== false)
					{
						$finHead = true;
						break;
					}
					$contenuLigne = "$balise ";
					//je teste les différents regex
					$temp = preg_match_all($recherche, $balise, $data);
					if($temp>0)
					{
						$urlFav = $data[1][count($data[0])-1];
						$trouver = true;
						break;
					}

					$temp = preg_match_all($recherche2, $balise, $data);
					if($temp>0)
					{
						$urlFav = $data[1][count($data[0])-1];
						$trouver = true;
						break;
					}

					$temp = preg_match_all($recherche3, $balise, $data);
					if($temp>0)
					{
						$urlFav = $data[1][count($data[0])-1];
						$trouver = true;
						break;
					}

					$temp = preg_match_all($recherche4, $balise, $data);
					if($temp>0)
					{
						$urlFav = $data[1][count($data[0])-1];
						$trouver = true;
						break;
					}
				}
				
				//si on a trouvé un favicon, on s'arrête
				if($trouver)
				{
					break;
				}
			}
			@fclose($fichier);

			$urlFavSecour = "$pro" . "$urlRacine/favicon.ico";

			//si je n'ai pas trouvé de favicon défini dans la page, on va chercher le favicon par défaut
			if(!$trouver)
			{
				if (Favicon::imageExiste($urlFavSecour))
				{
					$urlFav = $urlFavSecour;
					$trouver = true;
				}
				//si le favicon par défaut n'existe pas non plus, je vais chercher, si c'est pas encore le cas, le favicon défini à la racine du site
				//c'est utile, par exemple, dans le cas de l'url d'un flux RSS qui n'aura pas de favicon, mais le site peut en avoir
				elseif($pro . $urlRacine != trim($this->getUrlSite()) && $pro . $urlRacine . "/" != trim($this->getUrlSite()))
				{
					$favIcon = new Favicon($pro . $urlRacine);
					$urlFav = $favIcon->getFavicon();
					if($urlFav != "")
					{
						$trouver = true;
					}
				}
			}
		}

		//si j'ai trouvé un favicon, je fais quelques vérifications
		if($trouver)
		{
			//j'ai eu le cas où il y a d'autres attribus dans le String récupérés.
			//on va donc les virer
			$pos=strpos($urlFav, "'");
			if($pos >0)
			{
				$urlFav = substr($urlFav, 0, $pos);
			}
			else
			{
				$pos=strpos($urlFav, "\"");
				if($pos >0)
				{
					$urlFav = substr($urlFav, 0, $pos);
				}
			}

			//j'ai eu le cas où il y avait des paramètres dans l'url, je me suis posé la question de savoir si je les garde ou non, j'ai décidé que non
			$recherche = "#(.+)[?].*#i";
			$temp = preg_match_all($recherche, $urlFav, $data);
			if($temp>0)
			{
				$urlFav = $data[1][count($data[0])-1];
			}

			//si le chemin est relatif, je le transforme en absolu
			if(strpos($urlFav, "http") === false)
			{
				//dans certains cas, l'url est absolue, mais sans le http.
				//on va donc tester si c'est le cas
				$urlFavTemp = Favicon::nettoieURL("http://" . $urlFav);

				if (Favicon::imageExiste($urlFavTemp))
				{
					$urlFav = $urlFavTemp;
				}
				//si elle n'existe pas, c'est que c'est un chemin relatif. On le transforme donc en absolu
				else
				{
					$urlFav = $pro."$url/$urlFav";
				}
			}
			//j'enlève tous les doubles /
			$urlFav = Favicon::nettoieURL($urlFav);

			$trouver = false;
			//on vérifie que le fichier icone existe bien et est accessible (j'ai eu le cas d'erreur 503)
			if (!Favicon::imageExiste($urlFav))
			{
				//si l'image n'existe pas, et que l'on a pas testé le fichier favicon.ico par défaut, on le teste
				if($urlFav != $urlFavSecour && Favicon::imageExiste($urlFavSecour))
				{
					$urlFav = $urlFavSecour;
					$trouver = true;
				}
				else
				{
					$urlFav = "";
				}
			}
			else
			{
				$trouver = true;
			}

			//si on n'a pas de favicon, on renvoie une chaine vide
			if(!$trouver)
			{
				$urlFav = "";
			}
		}
		else
		{
		 $urlFav = "";
		}
		
		return $urlFav;
	}


	/**
	 * fonction qui enlève les doubles slash dans une url
	 * @param $url	String	: url à nettoyer
	 * @return url nettoyé
	 */
	public static function nettoieURL($url)
	{
		//j'enlève tous les doubles
		$url = preg_replace("#[/]+#", "/", $url);

		//je rajoute le double / apres le http:
		$url = preg_replace("#:/#", "://", $url);

		return $url;
	}


	/**
	 * fonction qui vérifie si l'image existe.
	 * Gros bordel cette fonction : fopen peut renvoyer une page html si l'image n'est pas disponible. Dans ce cas, je teste si on a une balise <body> dans le fichier reçu.
	 * 								Il n'est pas impossible de trouver cette suite de caractère dans une image, mais trés peu problable, donc je m'en satisfais
	 * 								J'ai encore pas réglé le cas ou l'image est corrompu…
	 * @param $url	String	: url de l'image
	 * @return boolean
	 */
	public static function imageExiste($url)
	{
		$extension = strtolower(pathinfo($url, PATHINFO_EXTENSION));
		$valide = false;
		
		//si c'est un type d'image que gère php, j'essaie de l'ouvrir.
		//si on y arrive, c'est bien une image
				
		switch($extension)
		{
			case "jpg"	:
			case "jpeg" :
				$valide = @ImageCreateFromJpeg($url);
				break;
			case "png" :
				$valide = @ImageCreateFromPng($url);
				break;
			case "gif" :
				$valide = @ImageCreateFromGif($url);
				break;
				
			//si ce n'est pas un format connu, (un fichier ico par exemple),
			//je fais des tests un peu foireu, mais qui marchent dans la plupart des cas.
			default:

				if($fichier = @fopen($url, "rb"))
				{
					//dans certain cas, j'ai eu un fichier vide, donc fopen marche et je ne trouve pas de balise, mais ce n'est pas une image pour autant
					$vide = true;

					//dans certains cas, on a une page html d'erreur et donc fopen marche
					//je cherche donc une balise qui est sensé être dans une page html : <body> (j'ai pas mis <html> car bizarement, je suis déjà tombé sur un cas où elle n'était pas là...)
					while ($temp = @fgets($fichier))
					{
						$nb = preg_match("#<body#i", trim($temp), $data);
						if($nb>0)
						{
							return false;
						}

						//on sauve le fait que le fichier n'est pas vide
						if(trim($temp) != "")
						{
							$vide = false;
						}
					}
					@fclose($fichier);

					//si le fichier est vide, cela signifie que ce n'est pas une image
					if($vide)
					{
						return false;
					}

					//ça a bien l'air d'être une icone valide
					return true;
				}
		}
		
		if($valide)
		{
			return true;
		}
		return false;
	}
}

?>
