<?php
/**
 *
 *
 * Copyright 2012-2013 Superbaillot
 * This file is part of Sali.
 *
 *  Sali is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Sali is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Sali.  If not, see <http://www.gnu.org/licenses/>.
 */



class RechercheSali
{
	private $listeTag = array();
	private $listeMot = array();
	private $typeLien = array();


	public function getListeTag(){return $this->listeTag;}
	public function setListeTag($listeTag){$this->listeTag = $listeTag;}

	public function getListeMot(){return $this->listeMot;}
	public function setListeMot($listeMot){$this->listeMot = $listeMot;}

	public function getTypeLien(){return $this->typeLien;}
	public function setTypeLien($typeLien){$this->typeLien = $typeLien;}


	/**
	 * méthode qui ajoute une liste de mots à rechercher séparés par des ",".
	 *
	 * @param $mot	String	: liste de mots séparer par des ,
	 */
	public function ajouteMot($mot)
	{
		if($mot != "")
		{
			$liste = explode(" ", $mot);
			foreach($liste as $m)
			{
				$m = trim($m);
				if($m != "" && !in_array($m, $this->listeMot))
				{
					$this->listeMot[] = $m;
				}
			}
		}
	}


	/**
	 * méthode qui ajoute une liste de tags séparés par des ",". Les tags sont insensible à la casse (car je reformate tout comme je le veux)
	 *
	 * @param $tag	String	: liste de tags séparer par des ,
	 */
	public function ajouteTag($tag)
	{
		if($tag != "")
		{
			$liste = explode(",", $tag);
			foreach($liste as $t)
			{
				$t = trim(mb_convert_case($t, MB_CASE_TITLE, "UTF-8"));
				if($t != "" && !in_array($t, $this->listeTag))
				{
					$this->listeTag[] = $t;
				}
			}
		}
	}


	/**
	 * méthode qui ajoute une liste de mots à rechercher séparés par des ",".
	 *
	 * @param $mot	String	: liste de mots séparer par des ,
	 */
	public function ajouteExtension($ext)
	{
		if($ext != "")
		{
			$liste = explode(",", $ext);
			foreach($liste as $e)
			{
				$e =  strtolower(trim($e));
				if($e != "" && !in_array($e, $this->typeLien))
				{
					$this->typeLien[] = $e;
				}
			}
		}
	}


	/**
	 * méthode qui remet tous les champs à vide
	 */
	public function init()
	{
		$this->setListeTag(array());
		$this->setListeMot(array());
		$this->setTypeLien(array());
	}
}
?>
