<?php
/**
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Sali.
 *
 *  Sali is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Sali is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Sali.  If not, see <http://www.gnu.org/licenses/>.
 */
 ?>
<form method="post" name="formConfig" id="formConfig" enctype="multipart/form-data">
	<div class="opt">
		<label for="pseudo " class="label"><?php echo $langue->get("CONFIG_FORM_PSEUDO_LABEL");?></label>
		<input name="pseudo" id="pseudo" type="text" value="<?php echo $config->getPseudo();?>">
	</div>
	<div class="desc">
		<?php echo $langue->get("CONFIG_FORM_PSEUDO_DESC");?>
	</div>
	
	<hr>
	
	<div class="opt">
		<label for="passAncien" class="label"><?php echo $langue->get("CONFIG_FORM_OLD_PASS_LABEL");?></label>
		<input name="passAncien" id="passAncien" type="password" autocomplete="off">
	</div>
	<div class="desc">
		<?php echo $langue->get("CONFIG_FORM_OLD_PASS_DESC");?>
	</div>
	
	<div class="opt">
		<label for="pass" class="label"><?php echo $langue->get("CONFIG_FORM_NEW_PASS_LABEL");?></label>
		<input name="pass" id="pass" type="password" autocomplete="off">
	</div>
	<div class="desc">
		<?php echo $langue->get("CONFIG_FORM_NEW_PASS_DESC");?>
	</div>
	<div class="opt">
		<label for="pass2" class="label"><?php echo $langue->get("CONFIG_FORM_PASS_CONFIRM_LABEL");?></label>
		<input name="pass2" id="pass2" type="password" autocomplete="off">
	</div>
	<div class="desc">
		<?php echo $langue->get("CONFIG_FORM_PASS_CONFIRM_DESC");?>
	</div>
	
	<hr>
	<?php
		$logo = new Logo($langue, CHEMIN_DOSSIER_LOGO);
	?>
	<div class="opt">
		<label for="logo" class="label"><?php echo $langue->get("CONFIG_FORM_LOGO_LABEL");?></label>
		<input name="logo" id="logo" type="file">
	</div>
				
	<div class="desc">
		<?php echo $langue->get("CONFIG_FORM_LOGO_DESC");?>
	</div>
	
	<hr>
	
	<?php 
		//cas génériques
		
		foreach ($config->getListeOption() as $nomOption => $option)
		{
			//sinon, c'est un hr
			if(is_array($option))
			{
				if($config->estSpecifique($nomOption, true))
				{
					echo $config->affichageSpecifique($nomOption);
				}
				else
				{
					switch($option[1])
					{
						case Configuration::BOOLEAN :
							require("configurationBoolean.php");
							break;
							
						case Configuration::FLOAT :
						case Configuration::STRING :
							require("configurationString.php");
							break;
							
						case Configuration::LANGUE :
							require("configurationLangue.php");
							break;
					}
				}
			}
			else
			{
				echo "	<hr>";
			}
		}
	?>
	
	<hr>
	
	<div class="boutons">
		<input name="Enregistrer" id="Enregistrer" type="submit" value="<?php echo htmlspecialchars($langue->get("CONFIG_FORM_BTN_ENREGISTRER"));?>">
	</div>
</form>
