<?php
/**
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Sali.
 *
 *  Sali is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Sali is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Sali.  If not, see <http://www.gnu.org/licenses/>.
 */
 ?>
<?php 
		$versionEdit = $idLienModifier == $lien->getId();
		if($versionEdit)
		{
			?>
			<form action="#lien<?php echo $lien->getId()?>" method="post" name="editForm" id="editForm">
				<input name="id" id="id" type="hidden" value="<?php echo $lien->getId()?>">
			<?php
		}
		
		if($lien->getEtat() == ETAT_VISIBLE_TOUS || ($lien->getEtat() == ETAT_VISIBLE_ADMIN && $GLOBALS["connexion"]->estConnecte()))
		{
			$class = "lien";
			if($lien->getEtat() == ETAT_VISIBLE_ADMIN)
			{
				$class .= "Connecte";
			}
?>
				<div class="<?php echo $class;?>" id="lien<?php echo $lien->getId();?>">
					<div class="titre">
					<?php 
					//boutons d'éditions si on est connecté
					if($GLOBALS['connexion']->estConnecte())
					{
						$imgPrive = ($lien->getEtat() == ETAT_VISIBLE_ADMIN ? "fa fa-lock" : "fa fa-unlock");
						?>
						<div class="divEdit">
							<span title="<?php echo htmlspecialchars($GLOBALS["langue"]->get("EDITER", htmlentitiesUTF8($lien->getTitre())));?>" class="imgAction fa fa-pencil" onclick="edit(<?php echo $lien->getId();?>)"></span>
							<span title="<?php echo htmlspecialchars($GLOBALS["langue"]->get("SUPPRIMER", htmlentitiesUTF8($lien->getTitre())));?>" class="imgAction fa fa-times" onclick="supprimer(<?php echo $lien->getId() . ", $idPrec";?>)"></span>
						</div>
						<?php
					}
		
					//si on autorise les favicon dans la configuration
					if($GLOBALS["config"]->getRecupereFavicon())
					{
						//si on est pas dans une note et qu'on a un favicon, on l'affiche
						if($lien->getUrl() != "" && $lien->getFavicon() != "" && file_exists(REPERTOIRE_FAVICON . $lien->getFavicon()))
						{
						?>
						<img src="<?php echo REPERTOIRE_FAVICON . $lien->getFavicon();?>" title="<?php echo htmlspecialchars($lien->getTitre());?>" alt="<?php echo htmlspecialchars($lien->getTitre());?>" class="favicon">
						<?php
						}
						//si on est dans une note, on affiche le favicon de Sali
						elseif($lien->getUrl() == "")
						{
						?>
						<img src="<?php echo CHEMIN_FAVICON_SALI;?>" title="<?php echo htmlspecialchars($lien->getTitre());?>" alt="<?php echo htmlspecialchars($lien->getTitre());?>" class="favicon">
						<?php
						}
					}
					
					$complementTitre = "";
					
					if($lien->getUrl() == "")
					{
						$complementTitre = $GLOBALS["langue"]->get("NOTE") . " - ";
					}
					if(!$versionEdit)
					{
						?>
						<a href="<?php echo htmlspecialchars($lien->getUrlAffichee());?>" target="_blank" title="<?php echo htmlspecialchars($lien->getUrlAffichee());?>"><?php echo htmlentitiesUTF8($complementTitre . $lien->getTitre());?></a>
						<?php
					}
					else
					{
						?>
						<label for="urlEdit"><?php echo $GLOBALS["langue"]->get("LABEL_URL");?> : </label>
						<input name="urlEdit" id="urlEdit" type="url" value="<?php echo $lien->getUrl();?>">
						<br>
						<label for="titreEdit"><?php echo $GLOBALS["langue"]->get("LABEL_TITRE");?> : </label>
						<input name="titreEdit" id="titreEdit" type="text" value="<?php echo htmlspecialchars($lien->getTitre());?>">
						<?php
					}
					?>
						<div>
							<?php echo formatDate(strtotime($lien->getDate()));?>
						</div>
					</div>
					<?php 
					if(!$versionEdit)
					{
						?>
					<div class="commentaire">
					<?php
						echo $lien->getAppercu() . nl2br(lienClickable(htmlentitiesUTF8($lien->getCommentaire())));
					?>
					</div>
					<hr>
					<div class="listeTag">
						<a href="<?php echo $lien->getPermalien();?>" title="<?php echo $GLOBALS["langue"]->get("PERMALIEN");?>">#</a>
						<?php 
						if(count($lien->getListeTag()) > 0 )
						{
							foreach($lien->getListeTag() as $tag)
							{
							?>
							<span onclick="chercheTag('<?php echo htmlspecialchars($tag);?>')"><?php echo htmlentitiesUTF8(stripslashes($tag));?></span>
							<?php
							}
						}
						?>
					</div>
					<?php 
					}
					else
					{
						?>
					<div class="commentaire">
						<textarea id="commentaire" name="commentaireEdit"><?php echo $lien->getCommentaire();?></textarea>
						<br>
						<input name="adminEdit[]" id="adminEdit1" type="checkbox" value="1"<?php echo ($lien->getEtat() == ETAT_VISIBLE_ADMIN ? " checked" : "");?>></input>
						<label for="adminEdit1"><?php echo $GLOBALS["langue"]->get("PRIVE");?></label>
					</div>
					<div class="listeTag">
						<label for="tagsEdit"><?php echo $GLOBALS["langue"]->get("TAGS")?> : </label>
						<input name="tagsEdit" id="tagsEdit" type="text" value="<?php echo htmlspecialchars(stripslashes(implode(", ", $lien->getListeTag())));?>" list="dataListTag" onkeypress="verifMajDatalist(this)" autocomplete="off">
						<br>
						<input name="Enregistrer" id="Enregistrer" type="submit" value="<?php echo htmlspecialchars($GLOBALS["langue"]->get("ENREGISTRER"));?>">
						<button id="btnAnnuler" type="button" onclick="window.location='<?php echo ($idDetail > 0 ? "?id=$idDetail" : "?annuler#lien" . $idLienModifier);?>'"><?php echo $GLOBALS["langue"]->get("ANNULER");?></button>
					</div>
						<?php
					}
					?>
				</div>
<?php
		}
		if($versionEdit)
		{
			?>
			</form>
			<?php
		}
?>
