<?php
/**
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Sali.
 *
 *  Sali is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Sali is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Sali.  If not, see <http://www.gnu.org/licenses/>.
 */
 ?>
<!DOCTYPE HTML>
<html>
<?php require("Elements/head.php");?>
	<body>
	<?php
		require("Elements/header.php");
	?>
		<div id="contenu">
			<?php
				require("Elements/formulaireEdit.php");
				require("Elements/messageInfo.php");
				if($GLOBALS["connexion"]->estConnecte())
				{
					require("Elements/formulaireAjout.php");
				}
			?>
			<div class="container">
				<div id="options">
				<?php
					//bar de recherche qui contient aussi le formulaire d'ajout d'une nouvelle entrée 
					require("Elements/recherche.php");
				?>
				<div class="nuageTag">
			<?php
				//récupération du nombre max pour avoir une référence pour calculer la taille d'affichage des tags
				$listeTag = $GLOBALS['sali']->getListeTag();
		
				if(count($listeTag) > 0)
				{
					//les élements de $listeTag étant de la forme "tag"=>"nb"
					//on tri les tags par nombre pour prendre facilement le max
					arsort($listeTag);
					$lk = array_keys($listeTag);
					$max = $listeTag[$lk[0]];
				
					//on tri la liste par ordre alphabétique pour l'affichage
					ksort($listeTag);
				
					$premier = true;
				
					foreach ($listeTag as $tag => $nb)
					{
						if(!$premier)
						{
							?> - <?php
						}
						$premier = false;
				
						$class = "tag1";
						$ref = ($nb * 6)/$max;
				
						if($ref > 5 )
						{
							$class = "tag6";
						}
						elseif($ref > 4 )
						{
							$class = "tag5";
						}
						elseif($ref > 3 )
						{
							$class = "tag4";
						}
						elseif($ref > 2 )
						{
							$class = "tag3";
						}
						elseif($ref > 1 )
						{
							$class = "tag2";
						}
						?>
						<a href="<?php echo getServeur() . "?tag=" . urlencode(stripslashes($tag));?>" class="<?php echo $class;?>" title="<?php echo htmlspecialchars($GLOBALS["langue"]->get("LIENS", $nb));?>"><?php echo stripslashes($tag);?></a> 
						<?php 
					}
				}
				?>
			</div>
				</div>
				
				<div id="liste">
					<?php
						
						//récupération de la liste des liens
						$listeLiens = $GLOBALS['sali']->getListeLiens($filtreRecherche);
						require("Elements/pagination.php");
					?>
					<div id="listeLiens">
						<?php 
						$idPrec = 0;	//va servir pour afficher la liste au niveau du lien précedent en cas de suppression d'un lien, pour ne pas revenir au début de la liste
					
						//affichage des liens de la page
						$nbRef = $GLOBALS['config']->getNbLienParPage();
						$debut = (($pagination - 1) * $nbRef);
						$fin = $debut + $nbRef;
						$nbElement = count($listeLiens);
						
						for( $i = $debut ; $i < $fin ; $i++)
						{
							if($i >= $nbElement)
							{
								break;
							}
							$lien = $listeLiens[$i];
							
							require("Elements/lien.php");
							$idPrec = $lien->getId();
						}
						?>
					</div>
				<?php 
					require("Elements/pagination.php");
				?>
				</div>
			</div>
		</div>
	<?php require("Elements/footer.php");?>
	</body>
</html>
