<?php
/**
 * Ce script rassemble les definitions des paramétres du programme
 *
 * Copyright 2012-2013 Superbaillot
 * This file is part of Sali.
 *
 *  Sali is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Sali is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Sali.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

//import des fichiers communs (configuration_db, outils et outilsIHM) ainsi que définition des chemins vers les classes obljets
define("REPERTOIRE_INC", "Inc/");								//répertoires contenant les fichiers complémentaires
define("REPERTOIRE_SAUVEGARDE", "Save/");								//répertoires contenant les fichiers à sauvegarder
define("REPERTOIRE_FAVICON", REPERTOIRE_SAUVEGARDE . "Favicon/");								//répertoires contenant les favicons des liens
define("REPERTOIRE_SAUVEGARDE_LANG", REPERTOIRE_INC . "Lang/");
define("REPERTOIRE_VIGNETTE", REPERTOIRE_SAUVEGARDE . "Vignette/");


define("CHEMIN_IMPORT_OM_SALI", REPERTOIRE_INC . "OM/");
define("CHEMIN_IMPORT_OM_SALI_CLASS", CHEMIN_IMPORT_OM_SALI . "sali.class.php");
define("CHEMIN_IMPORT_OM_LIEN", CHEMIN_IMPORT_OM_SALI . "lien.class.php");
define("CHEMIN_IMPORT_OM_RECHERCHE_SALI", CHEMIN_IMPORT_OM_SALI . "recherche.class.php");
define("CHEMIN_IMPORT_OM_CONFIGURATION_SALI", CHEMIN_IMPORT_OM_SALI . "configurationSali.class.php");
define("FICHIER_CONFIG", REPERTOIRE_SAUVEGARDE . "config.xml");		//fichier de configuration
define("FICHIER_LISTES", REPERTOIRE_SAUVEGARDE . "sali.xml");			//fichier de sauvegarde des listes de liens et de catégories

define("CHEMIN_DOSSIER_LOGO",REPERTOIRE_SAUVEGARDE);
define("CHEMIN_JS","DOC/Js/");
define("CHEMIN_CSS","DOC/Css/");
define("CHEMIN_JS_SALI", CHEMIN_JS . "sali.js");
define("CHEMIN_CSS_SALI", CHEMIN_CSS . "sali.css");

require_once("saliInc.php");

//Importation des objets métier
require_once(CHEMIN_IMPORT_OM_LIEN);
require_once(CHEMIN_IMPORT_OM_RECHERCHE_SALI);
require_once(CHEMIN_IMPORT_OM_SALI_CLASS);
require_once(CHEMIN_IMPORT_OM_CONFIGURATION); 
require_once(CHEMIN_IMPORT_OM_CONFIGURATION_SALI);
require_once(CHEMIN_IMPORT_OM_FAVICON);
require_once(CHEMIN_IMPORT_OM_LANGUE);
require_once(CHEMIN_IMPORT_OM_LOGO);
require_once(CHEMIN_IMPORT_OM_CONNEXION);

$config = new ConfigurationSali();
$config->setFichierConf(FICHIER_CONFIG);
$config->setNomSession("connexionSuperbaillot");
$config->charger();

$langue = new Langue(REPERTOIRE_SAUVEGARDE_LANG, $config->getLangue());


define("NOM_SESSION_SALI", $config->getNomSession() . $config->getPseudo());				//nom de la variable de session qui va determiner si on est connecté ou non
define("CATEGORIE_SESSION", "saliCategorie" . $config->getPseudo());			//nom de la variable de session qui va sauvegarder la catégorie dernierement affichée pour la réafficher en cas d'action qui ne reprécise pas cette catégorie

define("PAGE_LISTE", 1);
define("PAGE_POPUP_AJOUT_LIEN", 2);
define("PAGE_CONFIG",3);
define("PAGE_APROPOS", 4);
define("PAGE_DETAIL", 5);
define("PAGE_RSS", 6);
define("PAGE_TAG", 7);
define("PAGE_IMAGES", 8);
define("MAX_PAGE_SALI", 8);

define("ETAT_VISIBLE_TOUS", 0);				//visiblité d'un lien pour tous le monde
define("ETAT_VISIBLE_ADMIN", 1);			//visiblité d'un lien pour tous l'admin
define("ETAT_SUPPRIMER",9);

define("URL_SALI", CHEMIN_SERVEUR . "/site/mesContributions-sali.php");
define("URL_SALI_ARCHIVE", CHEMIN_SERVEUR . "/site/DOC/Divers/Sali/Sali.zip");			//url vers le téléchargement de Sali
define("URL_CHECK_MAJ", CHEMIN_SERVEUR . "/site/checkMaj.php?projet=sali");			//url vers la vérificatin de nouvelle version

?>
